/********************************************************************************
 * 
 * Code generated with Wire-Format-Compiler R1907 (hg:293/f7ae80f3c35d)
 * 
 * Source Information:
 * ===================
 * Filename : hostscope.wfc
 * Copyright: 2019
 * Author   : Thomas Maier-Komor
 * E-Mail   : thomas@maier-komor.de
 * 
 * Code generated on 2019-09-12, 20:37:59 (CET).
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 ********************************************************************************/


/*
 * options from commandline:
 * 
 * options from file:hostscope.wfc:
 * author          : "Thomas Maier-Komor"
 * copyright       : 2019
 * email           : "thomas@maier-komor.de"
 * Optimize        : "speed"
 * toASCII         : ""
 * toJSON          : ""
 * toSink          : ""
 * toString        : ""
 * toWire          : ""
 * 
 * options from defaults:
 * AddPrefix       : "add_"
 * BaseClass       : ""
 * bytestype       : "std::string"
 * calcSize        : "calcSize"
 * ClearName       : "clear"
 * ClearPrefix     : "clear_"
 * endian          : "unknown"
 * ErrorHandling   : "cancel"
 * fromMemory      : "fromMemory"
 * GetPrefix       : ""
 * HasPrefix       : "has_"
 * inline          : ""
 * intsize         : 64
 * json_indent     : "json_indent"
 * lang            : "c++"
 * MutablePrefix   : "mutable_"
 * namespace       : ""
 * SetPrefix       : "set_"
 * SortMembers     : "id"
 * stringtype      : "std::string"
 * toMemory        : "toMemory"
 * UnknownField    : "skip"
 * VarIntBits      : 64
 * wfclib          : "static"
 * wireput         : ""
 * wiresize        : ""
 * 
 * disabled flags from defaults:
 * 	debug, SubClasses, withEqual, withUnequal
 * enabled flags from defaults:
 * 	asserts, genlib
 */

#include <stdlib.h>
#include <string.h>
#include "hostscope_wfc.h"

/* included from: <internal>
 * function:      wiresize
 * variant:       wiresize_generic
 */
static unsigned wiresize(varint_t u)
{
	unsigned x = 0;
	do ++x;
	while (u>>=7U);
	return x;
}


/* included from: <internal>
 * function:      write_varint
 * variant:       write_varint_generic
 */
static int write_varint(uint8_t *wire, ssize_t wl, varint_t v)
{
	uint8_t *w = wire;
	do {
		if (--wl < 0)
			return -1;
		uint8_t u8 = v & 0x7f;
		v >>= 7;
		if (v)
			u8 |= 0x80;
		*wire = u8;
		++wire;
	} while (v);
	return wire-w;
}


/* included from: <internal>
 * function:      read_varint
 * variant:       read_varint_default
 */
static unsigned read_varint(const uint8_t *wire, ssize_t wl, varint_t *r)
{
	uint8_t u8;
	int n = 0;
	varint_t v = 0;
	do {
		if (--wl < 0)
			return -2;
		u8 = *wire++;
		v |= (varint_t)(u8&~0x80) << (n*7);
		++n;
	} while ((u8 & 0x80) && (n < (64/7+1)));
	*r = v;
	if ((64 != 64) && (u8 & 0x80)) {
		while (*wire++ & 0x80)
			++n;
		++n;
	}
	return n;
}


/* included from: <internal>
 * function:      skip_content
 * variant:       skip_content
 */
static ssize_t skip_content(const uint8_t *wire, ssize_t wl, unsigned type)
{
	ssize_t n;
	switch (type) {
	case 0:
		n = 0;
		while (wire[n++]&0x80) {
			if (wl == n)
				return -3;
		}
		break;
	case 1:
		n = 8;
		break;
	case 2: {
			varint_t v = 0;
			unsigned l = read_varint(wire,wl,&v);
			if (0 == l)
				return -4;
			n = v + l;
			break;
		}
	case 3:
		n = 1;
		break;
	case 4:
		n = 2;
		break;
	case 5:
		n = 4;
		break;
	default:
		n = 0;
		return -5;
	}
	if (n > wl)
		return -6;
	return n;
}


HostScope::HostScope()
: m_metadata()
, m_hostinfo()
, m_loadavg()
, m_mem()
, m_power_supplies()
, m_linux_info()
, m_linux_vmstat()
, m_linux_cpus()
, m_processes()
, m_users()
, m_disks()
, m_netdevices()
, p_validbits(0)
{
}

void HostScope::clear()
{
	m_metadata.clear();
	m_hostinfo.clear();
	m_loadavg.clear();
	m_mem.clear();
	m_power_supplies.clear();
	m_linux_info.clear();
	m_linux_vmstat.clear();
	m_linux_cpus.clear();
	m_processes.clear();
	m_users.clear();
	m_disks.clear();
	m_netdevices.clear();
	p_validbits = 0;
}

ssize_t HostScope::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -7;
		switch (fid) {
		case 0xa:	// metadata id 1, type HostScope_MetaData, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -8;
				if (v != 0) {
					n = m_metadata.fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -9;
					a += v;
				}
			}
			break;
		case 0x12:	// hostinfo id 2, type HostScope_HostInfo, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -10;
				if (v != 0) {
					n = m_hostinfo.fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -11;
					a += v;
				}
			}
			p_validbits |= ((uint8_t)1U << 0);
			break;
		case 0x1a:	// loadavg id 3, type HostScope_LoadAvg, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -12;
				if (v != 0) {
					n = m_loadavg.fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -13;
					a += v;
				}
			}
			p_validbits |= ((uint8_t)1U << 1);
			break;
		case 0x22:	// mem id 4, type HostScope_Memory, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -14;
				if (v != 0) {
					n = m_mem.fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -15;
					a += v;
				}
			}
			p_validbits |= ((uint8_t)1U << 2);
			break;
		case 0x2a:	// power_supplies id 5, type HostScope_PowerSupply, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -16;
				m_power_supplies.emplace_back();
				if (v != 0) {
					n = m_power_supplies.back().fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -17;
					a += v;
				}
			}
			break;
		case 0x42:	// linux_info id 8, type HostScope_LinuxInfo, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -18;
				if (v != 0) {
					n = m_linux_info.fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -19;
					a += v;
				}
			}
			p_validbits |= ((uint8_t)1U << 3);
			break;
		case 0x4a:	// linux_vmstat id 9, type HostScope_LinuxVmstat, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -20;
				if (v != 0) {
					n = m_linux_vmstat.fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -21;
					a += v;
				}
			}
			p_validbits |= ((uint8_t)1U << 4);
			break;
		case 0x52:	// linux_cpus id 10, type HostScope_LinuxCPU, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -22;
				m_linux_cpus.emplace_back();
				if (v != 0) {
					n = m_linux_cpus.back().fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -23;
					a += v;
				}
			}
			break;
		case 0x62:	// processes id 12, type HostScope_Process, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -24;
				m_processes.emplace_back();
				if (v != 0) {
					n = m_processes.back().fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -25;
					a += v;
				}
			}
			break;
		case 0x82:	// users id 16, type HostScope_User, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -26;
				m_users.emplace_back();
				if (v != 0) {
					n = m_users.back().fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -27;
					a += v;
				}
			}
			break;
		case 0x8a:	// disks id 17, type HostScope_Disk, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -28;
				m_disks.emplace_back();
				if (v != 0) {
					n = m_disks.back().fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -29;
					a += v;
				}
			}
			break;
		case 0x92:	// netdevices id 18, type HostScope_NetDevice, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -30;
				m_netdevices.emplace_back();
				if (v != 0) {
					n = m_netdevices.back().fromMemory((const uint8_t*)a,v);
					if (n != (ssize_t)v)
						return -31;
					a += v;
				}
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -32;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -33;
	return a-(const uint8_t *)b;
}

size_t HostScope::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// 'metadata': id=1, encoding=2, tag=0xa
	if (a >= e)
		return -34;
	*a++ = 0xa;
	ssize_t metadata_ws = m_metadata.calcSize();
	n = write_varint(a,e-a,metadata_ws);
	a += n;
	if ((n <= 0) || (metadata_ws > (e-a)))
		return -35;
	n = m_metadata.toMemory(a,e-a);
	a += n;
	assert(n == metadata_ws);
	// has hostinfo?
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		// 'hostinfo': id=2, encoding=2, tag=0x12
		if (a >= e)
			return -36;
		*a++ = 0x12;
		ssize_t hostinfo_ws = m_hostinfo.calcSize();
		n = write_varint(a,e-a,hostinfo_ws);
		a += n;
		if ((n <= 0) || (hostinfo_ws > (e-a)))
			return -37;
		n = m_hostinfo.toMemory(a,e-a);
		a += n;
		assert(n == hostinfo_ws);
	}
	// has loadavg?
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		// 'loadavg': id=3, encoding=2, tag=0x1a
		if (a >= e)
			return -38;
		*a++ = 0x1a;
		ssize_t loadavg_ws = m_loadavg.calcSize();
		n = write_varint(a,e-a,loadavg_ws);
		a += n;
		if ((n <= 0) || (loadavg_ws > (e-a)))
			return -39;
		n = m_loadavg.toMemory(a,e-a);
		a += n;
		assert(n == loadavg_ws);
	}
	// has mem?
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		// 'mem': id=4, encoding=2, tag=0x22
		if (a >= e)
			return -40;
		*a++ = 0x22;
		ssize_t mem_ws = m_mem.calcSize();
		n = write_varint(a,e-a,mem_ws);
		a += n;
		if ((n <= 0) || (mem_ws > (e-a)))
			return -41;
		n = m_mem.toMemory(a,e-a);
		a += n;
		assert(n == mem_ws);
	}
	for (size_t x = 0, y = m_power_supplies.size(); x != y; ++x) {
		// 'power_supplies': id=5, encoding=2, tag=0x2a
		if (a >= e)
			return -42;
		*a++ = 0x2a;
		ssize_t power_supplies_ws = m_power_supplies[x].calcSize();
		n = write_varint(a,e-a,power_supplies_ws);
		a += n;
		if ((n <= 0) || (power_supplies_ws > (e-a)))
			return -43;
		n = m_power_supplies[x].toMemory(a,e-a);
		a += n;
		assert(n == power_supplies_ws);
	}
	// has linux_info?
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		// 'linux_info': id=8, encoding=2, tag=0x42
		if (a >= e)
			return -44;
		*a++ = 0x42;
		ssize_t linux_info_ws = m_linux_info.calcSize();
		n = write_varint(a,e-a,linux_info_ws);
		a += n;
		if ((n <= 0) || (linux_info_ws > (e-a)))
			return -45;
		n = m_linux_info.toMemory(a,e-a);
		a += n;
		assert(n == linux_info_ws);
	}
	// has linux_vmstat?
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		// 'linux_vmstat': id=9, encoding=2, tag=0x4a
		if (a >= e)
			return -46;
		*a++ = 0x4a;
		ssize_t linux_vmstat_ws = m_linux_vmstat.calcSize();
		n = write_varint(a,e-a,linux_vmstat_ws);
		a += n;
		if ((n <= 0) || (linux_vmstat_ws > (e-a)))
			return -47;
		n = m_linux_vmstat.toMemory(a,e-a);
		a += n;
		assert(n == linux_vmstat_ws);
	}
	for (size_t x = 0, y = m_linux_cpus.size(); x != y; ++x) {
		// 'linux_cpus': id=10, encoding=2, tag=0x52
		if (a >= e)
			return -48;
		*a++ = 0x52;
		ssize_t linux_cpus_ws = m_linux_cpus[x].calcSize();
		n = write_varint(a,e-a,linux_cpus_ws);
		a += n;
		if ((n <= 0) || (linux_cpus_ws > (e-a)))
			return -49;
		n = m_linux_cpus[x].toMemory(a,e-a);
		a += n;
		assert(n == linux_cpus_ws);
	}
	for (size_t x = 0, y = m_processes.size(); x != y; ++x) {
		// 'processes': id=12, encoding=2, tag=0x62
		if (a >= e)
			return -50;
		*a++ = 0x62;
		ssize_t processes_ws = m_processes[x].calcSize();
		n = write_varint(a,e-a,processes_ws);
		a += n;
		if ((n <= 0) || (processes_ws > (e-a)))
			return -51;
		n = m_processes[x].toMemory(a,e-a);
		a += n;
		assert(n == processes_ws);
	}
	for (size_t x = 0, y = m_users.size(); x != y; ++x) {
		// 'users': id=16, encoding=2, tag=0x82
		if (2 > (e-a))
			return -52;
		*a++ = 0x82;
		*a++ = 0x1;
		ssize_t users_ws = m_users[x].calcSize();
		n = write_varint(a,e-a,users_ws);
		a += n;
		if ((n <= 0) || (users_ws > (e-a)))
			return -53;
		n = m_users[x].toMemory(a,e-a);
		a += n;
		assert(n == users_ws);
	}
	for (size_t x = 0, y = m_disks.size(); x != y; ++x) {
		// 'disks': id=17, encoding=2, tag=0x8a
		if (2 > (e-a))
			return -54;
		*a++ = 0x8a;
		*a++ = 0x1;
		ssize_t disks_ws = m_disks[x].calcSize();
		n = write_varint(a,e-a,disks_ws);
		a += n;
		if ((n <= 0) || (disks_ws > (e-a)))
			return -55;
		n = m_disks[x].toMemory(a,e-a);
		a += n;
		assert(n == disks_ws);
	}
	for (size_t x = 0, y = m_netdevices.size(); x != y; ++x) {
		// 'netdevices': id=18, encoding=2, tag=0x92
		if (2 > (e-a))
			return -56;
		*a++ = 0x92;
		*a++ = 0x1;
		ssize_t netdevices_ws = m_netdevices[x].calcSize();
		n = write_varint(a,e-a,netdevices_ws);
		a += n;
		if ((n <= 0) || (netdevices_ws > (e-a)))
			return -57;
		n = m_netdevices[x].toMemory(a,e-a);
		a += n;
		assert(n == netdevices_ws);
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope::calcSize() const
{
	// metadata: tagsize 1
	size_t r = 1;	// required size, default is fixed length
	// metadata
	size_t metadata_s = m_metadata.calcSize();
	r += metadata_s + wiresize(metadata_s);
	// hostinfo
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		size_t hostinfo_s = m_hostinfo.calcSize();
		r += hostinfo_s + wiresize(hostinfo_s) + 1 /* tag(id) 0x10 */;
	}
	// loadavg
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		size_t loadavg_s = m_loadavg.calcSize();
		r += loadavg_s + wiresize(loadavg_s) + 1 /* tag(id) 0x18 */;
	}
	// mem
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		size_t mem_s = m_mem.calcSize();
		r += mem_s + wiresize(mem_s) + 1 /* tag(id) 0x20 */;
	}
	// power_supplies
	// repeated message power_supplies
	for (size_t x = 0, y = m_power_supplies.size(); x < y; ++x) {
		size_t s = m_power_supplies[x].calcSize();
		r += wiresize(s);
		r += s + 1 /* tag(id) 0x28 */;
	}
	// linux_info
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		size_t linux_info_s = m_linux_info.calcSize();
		r += linux_info_s + wiresize(linux_info_s) + 1 /* tag(id) 0x40 */;
	}
	// linux_vmstat
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		size_t linux_vmstat_s = m_linux_vmstat.calcSize();
		r += linux_vmstat_s + wiresize(linux_vmstat_s) + 1 /* tag(id) 0x48 */;
	}
	// linux_cpus
	// repeated message linux_cpus
	for (size_t x = 0, y = m_linux_cpus.size(); x < y; ++x) {
		size_t s = m_linux_cpus[x].calcSize();
		r += wiresize(s);
		r += s + 1 /* tag(id) 0x50 */;
	}
	// processes
	// repeated message processes
	for (size_t x = 0, y = m_processes.size(); x < y; ++x) {
		size_t s = m_processes[x].calcSize();
		r += wiresize(s);
		r += s + 1 /* tag(id) 0x60 */;
	}
	// users
	// repeated message users
	for (size_t x = 0, y = m_users.size(); x < y; ++x) {
		size_t s = m_users[x].calcSize();
		r += wiresize(s);
		r += s + 2 /* tag(id) 0x80 */;
	}
	// disks
	// repeated message disks
	for (size_t x = 0, y = m_disks.size(); x < y; ++x) {
		size_t s = m_disks[x].calcSize();
		r += wiresize(s);
		r += s + 2 /* tag(id) 0x88 */;
	}
	// netdevices
	// repeated message netdevices
	for (size_t x = 0, y = m_netdevices.size(); x < y; ++x) {
		size_t s = m_netdevices[x].calcSize();
		r += wiresize(s);
		r += s + 2 /* tag(id) 0x90 */;
	}
	return r;
}

HostScope_MetaData::HostScope_MetaData()
: m_protocol_version(0)
, m_timestamp(0)
, m_hostscope_version()
{
}

void HostScope_MetaData::clear()
{
	m_protocol_version = 0;
	m_timestamp = 0;
	m_hostscope_version.clear();
}

ssize_t HostScope_MetaData::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -58;
		switch (fid) {
		case 0x8:	// protocol_version id 1, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -59;
				a += n;
				m_protocol_version = v;
			}
			break;
		case 0x10:	// timestamp id 2, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -60;
				a += n;
				m_timestamp = v;
			}
			break;
		case 0x1a:	// hostscope_version id 3, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -61;
				m_hostscope_version.assign((const char*)a,v);
				a += v;
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -62;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -63;
	return a-(const uint8_t *)b;
}

size_t HostScope_MetaData::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// 'protocol_version': id=1, encoding=0, tag=0x8
	if (a >= e)
		return -64;
	*a++ = 0x8;
	n = write_varint(a,e-a,m_protocol_version);
	if (n <= 0)
		return -65;
	a += n;
	// 'timestamp': id=2, encoding=0, tag=0x10
	if (a >= e)
		return -66;
	*a++ = 0x10;
	n = write_varint(a,e-a,m_timestamp);
	if (n <= 0)
		return -67;
	a += n;
	// 'hostscope_version': id=3, encoding=2, tag=0x1a
	if (a >= e)
		return -68;
	*a++ = 0x1a;
	ssize_t hostscope_version_s = m_hostscope_version.size();
	n = write_varint(a,e-a,hostscope_version_s);
	a += n;
	if ((n <= 0) || ((e-a) < hostscope_version_s))
		return -69;
	memcpy(a,m_hostscope_version.data(),hostscope_version_s);
	a += hostscope_version_s;
	assert(a <= e);
	return a-b;
}

size_t HostScope_MetaData::calcSize() const
{
	// protocol_version: tagsize 1
	// timestamp: tagsize 1
	// hostscope_version: tagsize 1
	size_t r = 3;	// required size, default is fixed length
	// protocol_version
	r += wiresize((varint_t)m_protocol_version);
	// timestamp
	r += wiresize((varint_t)m_timestamp);
	// hostscope_version
	size_t hostscope_version_s = m_hostscope_version.size();
	r += hostscope_version_s + wiresize(hostscope_version_s);
	return r;
}

HostScope_HostInfo::HostScope_HostInfo()
: m_hostname()
, m_uptime(0)
, m_osname()
, m_osrelease()
, m_osversion()
, m_proctype()
, m_machtype()
, m_minuseruid(0)
, p_validbits(0)
{
}

void HostScope_HostInfo::clear()
{
	m_hostname.clear();
	m_uptime = 0;
	m_osname.clear();
	m_osrelease.clear();
	m_osversion.clear();
	m_proctype.clear();
	m_machtype.clear();
	m_minuseruid = 0;
	p_validbits = 0;
}

ssize_t HostScope_HostInfo::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -70;
		switch (fid) {
		case 0xa:	// hostname id 1, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -71;
				m_hostname.assign((const char*)a,v);
				a += v;
			}
			p_validbits |= ((uint8_t)1U << 0);
			break;
		case 0x10:	// uptime id 2, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -72;
				a += n;
				set_uptime(v);
			}
			break;
		case 0x1a:	// osname id 3, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -73;
				m_osname.assign((const char*)a,v);
				a += v;
			}
			p_validbits |= ((uint8_t)1U << 2);
			break;
		case 0x22:	// osrelease id 4, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -74;
				m_osrelease.assign((const char*)a,v);
				a += v;
			}
			p_validbits |= ((uint8_t)1U << 3);
			break;
		case 0x2a:	// osversion id 5, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -75;
				m_osversion.assign((const char*)a,v);
				a += v;
			}
			p_validbits |= ((uint8_t)1U << 4);
			break;
		case 0x32:	// proctype id 6, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -76;
				m_proctype.assign((const char*)a,v);
				a += v;
			}
			p_validbits |= ((uint8_t)1U << 5);
			break;
		case 0x3a:	// machtype id 7, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -77;
				m_machtype.assign((const char*)a,v);
				a += v;
			}
			p_validbits |= ((uint8_t)1U << 6);
			break;
		case 0x40:	// minuseruid id 8, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -78;
				a += n;
				set_minuseruid(v);
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -79;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -80;
	return a-(const uint8_t *)b;
}

size_t HostScope_HostInfo::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// has hostname?
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		// 'hostname': id=1, encoding=2, tag=0xa
		if (a >= e)
			return -81;
		*a++ = 0xa;
		ssize_t hostname_s = m_hostname.size();
		n = write_varint(a,e-a,hostname_s);
		a += n;
		if ((n <= 0) || ((e-a) < hostname_s))
			return -82;
		memcpy(a,m_hostname.data(),hostname_s);
		a += hostname_s;
	}
	// has uptime?
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		// 'uptime': id=2, encoding=0, tag=0x10
		if (a >= e)
			return -83;
		*a++ = 0x10;
		n = write_varint(a,e-a,m_uptime);
		if (n <= 0)
			return -84;
		a += n;
	}
	// has osname?
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		// 'osname': id=3, encoding=2, tag=0x1a
		if (a >= e)
			return -85;
		*a++ = 0x1a;
		ssize_t osname_s = m_osname.size();
		n = write_varint(a,e-a,osname_s);
		a += n;
		if ((n <= 0) || ((e-a) < osname_s))
			return -86;
		memcpy(a,m_osname.data(),osname_s);
		a += osname_s;
	}
	// has osrelease?
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		// 'osrelease': id=4, encoding=2, tag=0x22
		if (a >= e)
			return -87;
		*a++ = 0x22;
		ssize_t osrelease_s = m_osrelease.size();
		n = write_varint(a,e-a,osrelease_s);
		a += n;
		if ((n <= 0) || ((e-a) < osrelease_s))
			return -88;
		memcpy(a,m_osrelease.data(),osrelease_s);
		a += osrelease_s;
	}
	// has osversion?
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		// 'osversion': id=5, encoding=2, tag=0x2a
		if (a >= e)
			return -89;
		*a++ = 0x2a;
		ssize_t osversion_s = m_osversion.size();
		n = write_varint(a,e-a,osversion_s);
		a += n;
		if ((n <= 0) || ((e-a) < osversion_s))
			return -90;
		memcpy(a,m_osversion.data(),osversion_s);
		a += osversion_s;
	}
	// has proctype?
	if (0 != (p_validbits & ((uint8_t)1U << 5))) {
		// 'proctype': id=6, encoding=2, tag=0x32
		if (a >= e)
			return -91;
		*a++ = 0x32;
		ssize_t proctype_s = m_proctype.size();
		n = write_varint(a,e-a,proctype_s);
		a += n;
		if ((n <= 0) || ((e-a) < proctype_s))
			return -92;
		memcpy(a,m_proctype.data(),proctype_s);
		a += proctype_s;
	}
	// has machtype?
	if (0 != (p_validbits & ((uint8_t)1U << 6))) {
		// 'machtype': id=7, encoding=2, tag=0x3a
		if (a >= e)
			return -93;
		*a++ = 0x3a;
		ssize_t machtype_s = m_machtype.size();
		n = write_varint(a,e-a,machtype_s);
		a += n;
		if ((n <= 0) || ((e-a) < machtype_s))
			return -94;
		memcpy(a,m_machtype.data(),machtype_s);
		a += machtype_s;
	}
	// has minuseruid?
	if (0 != (p_validbits & ((uint8_t)1U << 7))) {
		// 'minuseruid': id=8, encoding=0, tag=0x40
		if (a >= e)
			return -95;
		*a++ = 0x40;
		n = write_varint(a,e-a,m_minuseruid);
		if (n <= 0)
			return -96;
		a += n;
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope_HostInfo::calcSize() const
{
	size_t r = 0;	// required size, default is fixed length
	// hostname
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		size_t hostname_s = m_hostname.size();
		r += hostname_s + wiresize(hostname_s) + 1 /* tag(id) 0x8 */;
	}
	// uptime
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		r += wiresize((varint_t)m_uptime) + 1 /* tag(id) 0x10 */;
	}
	// osname
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		size_t osname_s = m_osname.size();
		r += osname_s + wiresize(osname_s) + 1 /* tag(id) 0x18 */;
	}
	// osrelease
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		size_t osrelease_s = m_osrelease.size();
		r += osrelease_s + wiresize(osrelease_s) + 1 /* tag(id) 0x20 */;
	}
	// osversion
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		size_t osversion_s = m_osversion.size();
		r += osversion_s + wiresize(osversion_s) + 1 /* tag(id) 0x28 */;
	}
	// proctype
	if (0 != (p_validbits & ((uint8_t)1U << 5))) {
		size_t proctype_s = m_proctype.size();
		r += proctype_s + wiresize(proctype_s) + 1 /* tag(id) 0x30 */;
	}
	// machtype
	if (0 != (p_validbits & ((uint8_t)1U << 6))) {
		size_t machtype_s = m_machtype.size();
		r += machtype_s + wiresize(machtype_s) + 1 /* tag(id) 0x38 */;
	}
	// minuseruid
	if (0 != (p_validbits & ((uint8_t)1U << 7))) {
		r += wiresize((varint_t)m_minuseruid) + 1 /* tag(id) 0x40 */;
	}
	return r;
}

HostScope_LoadAvg::HostScope_LoadAvg()
: m_loadav1m(0)
, m_loadav5m(0)
, m_loadav15m(0)
{
}

void HostScope_LoadAvg::clear()
{
	m_loadav1m = 0;
	m_loadav5m = 0;
	m_loadav15m = 0;
}

ssize_t HostScope_LoadAvg::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -97;
		switch (fid) {
		case 0x8:	// loadav1m id 1, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -98;
				a += n;
				m_loadav1m = v;
			}
			break;
		case 0x10:	// loadav5m id 2, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -99;
				a += n;
				m_loadav5m = v;
			}
			break;
		case 0x18:	// loadav15m id 3, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -100;
				a += n;
				m_loadav15m = v;
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -101;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -102;
	return a-(const uint8_t *)b;
}

size_t HostScope_LoadAvg::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// 'loadav1m': id=1, encoding=0, tag=0x8
	if (a >= e)
		return -103;
	*a++ = 0x8;
	n = write_varint(a,e-a,m_loadav1m);
	if (n <= 0)
		return -104;
	a += n;
	// 'loadav5m': id=2, encoding=0, tag=0x10
	if (a >= e)
		return -105;
	*a++ = 0x10;
	n = write_varint(a,e-a,m_loadav5m);
	if (n <= 0)
		return -106;
	a += n;
	// 'loadav15m': id=3, encoding=0, tag=0x18
	if (a >= e)
		return -107;
	*a++ = 0x18;
	n = write_varint(a,e-a,m_loadav15m);
	if (n <= 0)
		return -108;
	a += n;
	assert(a <= e);
	return a-b;
}

size_t HostScope_LoadAvg::calcSize() const
{
	// loadav1m: tagsize 1
	// loadav5m: tagsize 1
	// loadav15m: tagsize 1
	size_t r = 3;	// required size, default is fixed length
	// loadav1m
	r += wiresize((varint_t)m_loadav1m);
	// loadav5m
	r += wiresize((varint_t)m_loadav5m);
	// loadav15m
	r += wiresize((varint_t)m_loadav15m);
	return r;
}

HostScope_Memory::HostScope_Memory()
: m_physical(0)
, m_free(0)
, m_swapsize(0)
, m_pagedout(0)
, m_locked(0)
, p_validbits(0)
{
}

void HostScope_Memory::clear()
{
	m_physical = 0;
	m_free = 0;
	m_swapsize = 0;
	m_pagedout = 0;
	m_locked = 0;
	p_validbits = 0;
}

ssize_t HostScope_Memory::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -109;
		switch (fid) {
		case 0x8:	// physical id 1, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -110;
				a += n;
				set_physical(v);
			}
			break;
		case 0x10:	// free id 2, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -111;
				a += n;
				set_free(v);
			}
			break;
		case 0x18:	// swapsize id 3, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -112;
				a += n;
				set_swapsize(v);
			}
			break;
		case 0x20:	// pagedout id 4, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -113;
				a += n;
				set_pagedout(v);
			}
			break;
		case 0x28:	// locked id 5, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -114;
				a += n;
				set_locked(v);
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -115;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -116;
	return a-(const uint8_t *)b;
}

size_t HostScope_Memory::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// has physical?
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		// 'physical': id=1, encoding=0, tag=0x8
		if (a >= e)
			return -117;
		*a++ = 0x8;
		n = write_varint(a,e-a,m_physical);
		if (n <= 0)
			return -118;
		a += n;
	}
	// has free?
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		// 'free': id=2, encoding=0, tag=0x10
		if (a >= e)
			return -119;
		*a++ = 0x10;
		n = write_varint(a,e-a,m_free);
		if (n <= 0)
			return -120;
		a += n;
	}
	// has swapsize?
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		// 'swapsize': id=3, encoding=0, tag=0x18
		if (a >= e)
			return -121;
		*a++ = 0x18;
		n = write_varint(a,e-a,m_swapsize);
		if (n <= 0)
			return -122;
		a += n;
	}
	// has pagedout?
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		// 'pagedout': id=4, encoding=0, tag=0x20
		if (a >= e)
			return -123;
		*a++ = 0x20;
		n = write_varint(a,e-a,m_pagedout);
		if (n <= 0)
			return -124;
		a += n;
	}
	// has locked?
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		// 'locked': id=5, encoding=0, tag=0x28
		if (a >= e)
			return -125;
		*a++ = 0x28;
		n = write_varint(a,e-a,m_locked);
		if (n <= 0)
			return -126;
		a += n;
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope_Memory::calcSize() const
{
	size_t r = 0;	// required size, default is fixed length
	// physical
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		r += wiresize((varint_t)m_physical) + 1 /* tag(id) 0x8 */;
	}
	// free
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		r += wiresize((varint_t)m_free) + 1 /* tag(id) 0x10 */;
	}
	// swapsize
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		r += wiresize((varint_t)m_swapsize) + 1 /* tag(id) 0x18 */;
	}
	// pagedout
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		r += wiresize((varint_t)m_pagedout) + 1 /* tag(id) 0x20 */;
	}
	// locked
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		r += wiresize((varint_t)m_locked) + 1 /* tag(id) 0x28 */;
	}
	return r;
}

HostScope_PowerSupply::HostScope_PowerSupply()
: m_name()
, m_state()
, m_capacity(0)
, p_validbits(0)
{
}

void HostScope_PowerSupply::clear()
{
	m_name.clear();
	m_state.clear();
	m_capacity = 0;
	p_validbits = 0;
}

ssize_t HostScope_PowerSupply::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -127;
		switch (fid) {
		case 0xa:	// name id 1, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -128;
				m_name.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x12:	// state id 2, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -129;
				m_state.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x18:	// capacity id 3, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -130;
				a += n;
				set_capacity(v);
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -131;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -132;
	return a-(const uint8_t *)b;
}

size_t HostScope_PowerSupply::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// 'name': id=1, encoding=2, tag=0xa
	if (a >= e)
		return -133;
	*a++ = 0xa;
	ssize_t name_s = m_name.size();
	n = write_varint(a,e-a,name_s);
	a += n;
	if ((n <= 0) || ((e-a) < name_s))
		return -134;
	memcpy(a,m_name.data(),name_s);
	a += name_s;
	// 'state': id=2, encoding=2, tag=0x12
	if (a >= e)
		return -135;
	*a++ = 0x12;
	ssize_t state_s = m_state.size();
	n = write_varint(a,e-a,state_s);
	a += n;
	if ((n <= 0) || ((e-a) < state_s))
		return -136;
	memcpy(a,m_state.data(),state_s);
	a += state_s;
	// has capacity?
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		// 'capacity': id=3, encoding=0, tag=0x18
		if (a >= e)
			return -137;
		*a++ = 0x18;
		n = write_varint(a,e-a,m_capacity);
		if (n <= 0)
			return -138;
		a += n;
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope_PowerSupply::calcSize() const
{
	// name: tagsize 1
	// state: tagsize 1
	size_t r = 2;	// required size, default is fixed length
	// name
	size_t name_s = m_name.size();
	r += name_s + wiresize(name_s);
	// state
	size_t state_s = m_state.size();
	r += state_s + wiresize(state_s);
	// capacity
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		r += wiresize((varint_t)m_capacity) + 1 /* tag(id) 0x18 */;
	}
	return r;
}

HostScope_LinuxInfo::HostScope_LinuxInfo()
: m_forks(0)
, m_ctxtsw(0)
, m_intrs(0)
, m_sirqs(0)
, p_validbits(0)
{
}

void HostScope_LinuxInfo::clear()
{
	m_forks = 0;
	m_ctxtsw = 0;
	m_intrs = 0;
	m_sirqs = 0;
	p_validbits = 0;
}

ssize_t HostScope_LinuxInfo::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -139;
		switch (fid) {
		case 0x8:	// forks id 1, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -140;
				a += n;
				set_forks(v);
			}
			break;
		case 0x10:	// ctxtsw id 2, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -141;
				a += n;
				set_ctxtsw(v);
			}
			break;
		case 0x18:	// intrs id 3, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -142;
				a += n;
				set_intrs(v);
			}
			break;
		case 0x20:	// sirqs id 4, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -143;
				a += n;
				set_sirqs(v);
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -144;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -145;
	return a-(const uint8_t *)b;
}

size_t HostScope_LinuxInfo::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// has forks?
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		// 'forks': id=1, encoding=0, tag=0x8
		if (a >= e)
			return -146;
		*a++ = 0x8;
		n = write_varint(a,e-a,m_forks);
		if (n <= 0)
			return -147;
		a += n;
	}
	// has ctxtsw?
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		// 'ctxtsw': id=2, encoding=0, tag=0x10
		if (a >= e)
			return -148;
		*a++ = 0x10;
		n = write_varint(a,e-a,m_ctxtsw);
		if (n <= 0)
			return -149;
		a += n;
	}
	// has intrs?
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		// 'intrs': id=3, encoding=0, tag=0x18
		if (a >= e)
			return -150;
		*a++ = 0x18;
		n = write_varint(a,e-a,m_intrs);
		if (n <= 0)
			return -151;
		a += n;
	}
	// has sirqs?
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		// 'sirqs': id=4, encoding=0, tag=0x20
		if (a >= e)
			return -152;
		*a++ = 0x20;
		n = write_varint(a,e-a,m_sirqs);
		if (n <= 0)
			return -153;
		a += n;
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope_LinuxInfo::calcSize() const
{
	size_t r = 0;	// required size, default is fixed length
	// forks
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		r += wiresize((varint_t)m_forks) + 1 /* tag(id) 0x8 */;
	}
	// ctxtsw
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		r += wiresize((varint_t)m_ctxtsw) + 1 /* tag(id) 0x10 */;
	}
	// intrs
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		r += wiresize((varint_t)m_intrs) + 1 /* tag(id) 0x18 */;
	}
	// sirqs
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		r += wiresize((varint_t)m_sirqs) + 1 /* tag(id) 0x20 */;
	}
	return r;
}

HostScope_LinuxVmstat::HostScope_LinuxVmstat()
: m_nr_free_pages(0)
, m_nr_mlock(0)
, m_nr_anon_pages(0)
, m_nr_file_pages(0)
, m_nr_kernel_stack(0)
, m_nr_shmem(0)
, m_pgpgin(0)
, m_pgpgout(0)
, m_pgfree(0)
, m_pgfault(0)
, m_pgmajfault(0)
, p_validbits(0)
{
}

void HostScope_LinuxVmstat::clear()
{
	m_nr_free_pages = 0;
	m_nr_mlock = 0;
	m_nr_anon_pages = 0;
	m_nr_file_pages = 0;
	m_nr_kernel_stack = 0;
	m_nr_shmem = 0;
	m_pgpgin = 0;
	m_pgpgout = 0;
	m_pgfree = 0;
	m_pgfault = 0;
	m_pgmajfault = 0;
	p_validbits = 0;
}

ssize_t HostScope_LinuxVmstat::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -154;
		switch (fid) {
		case 0x8:	// nr_free_pages id 1, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -155;
				a += n;
				set_nr_free_pages(v);
			}
			break;
		case 0x40:	// nr_mlock id 8, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -156;
				a += n;
				set_nr_mlock(v);
			}
			break;
		case 0x48:	// nr_anon_pages id 9, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -157;
				a += n;
				set_nr_anon_pages(v);
			}
			break;
		case 0x58:	// nr_file_pages id 11, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -158;
				a += n;
				set_nr_file_pages(v);
			}
			break;
		case 0x88:	// nr_kernel_stack id 17, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -159;
				a += n;
				set_nr_kernel_stack(v);
			}
			break;
		case 0xc8:	// nr_shmem id 25, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -160;
				a += n;
				set_nr_shmem(v);
			}
			break;
		case 0x130:	// pgpgin id 38, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -161;
				a += n;
				set_pgpgin(v);
			}
			break;
		case 0x138:	// pgpgout id 39, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -162;
				a += n;
				set_pgpgout(v);
			}
			break;
		case 0x170:	// pgfree id 46, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -163;
				a += n;
				set_pgfree(v);
			}
			break;
		case 0x188:	// pgfault id 49, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -164;
				a += n;
				set_pgfault(v);
			}
			break;
		case 0x190:	// pgmajfault id 50, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -165;
				a += n;
				set_pgmajfault(v);
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -166;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -167;
	return a-(const uint8_t *)b;
}

size_t HostScope_LinuxVmstat::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// has nr_free_pages?
	if (0 != (p_validbits & ((uint16_t)1U << 0))) {
		// 'nr_free_pages': id=1, encoding=0, tag=0x8
		if (a >= e)
			return -168;
		*a++ = 0x8;
		n = write_varint(a,e-a,m_nr_free_pages);
		if (n <= 0)
			return -169;
		a += n;
	}
	// has nr_mlock?
	if (0 != (p_validbits & ((uint16_t)1U << 1))) {
		// 'nr_mlock': id=8, encoding=0, tag=0x40
		if (a >= e)
			return -170;
		*a++ = 0x40;
		n = write_varint(a,e-a,m_nr_mlock);
		if (n <= 0)
			return -171;
		a += n;
	}
	// has nr_anon_pages?
	if (0 != (p_validbits & ((uint16_t)1U << 2))) {
		// 'nr_anon_pages': id=9, encoding=0, tag=0x48
		if (a >= e)
			return -172;
		*a++ = 0x48;
		n = write_varint(a,e-a,m_nr_anon_pages);
		if (n <= 0)
			return -173;
		a += n;
	}
	// has nr_file_pages?
	if (0 != (p_validbits & ((uint16_t)1U << 3))) {
		// 'nr_file_pages': id=11, encoding=0, tag=0x58
		if (a >= e)
			return -174;
		*a++ = 0x58;
		n = write_varint(a,e-a,m_nr_file_pages);
		if (n <= 0)
			return -175;
		a += n;
	}
	// has nr_kernel_stack?
	if (0 != (p_validbits & ((uint16_t)1U << 4))) {
		// 'nr_kernel_stack': id=17, encoding=0, tag=0x88
		if (2 > (e-a))
			return -176;
		*a++ = 0x88;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_nr_kernel_stack);
		if (n <= 0)
			return -177;
		a += n;
	}
	// has nr_shmem?
	if (0 != (p_validbits & ((uint16_t)1U << 5))) {
		// 'nr_shmem': id=25, encoding=0, tag=0xc8
		if (2 > (e-a))
			return -178;
		*a++ = 0xc8;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_nr_shmem);
		if (n <= 0)
			return -179;
		a += n;
	}
	// has pgpgin?
	if (0 != (p_validbits & ((uint16_t)1U << 6))) {
		// 'pgpgin': id=38, encoding=0, tag=0x130
		if (2 > (e-a))
			return -180;
		*a++ = 0xb0;
		*a++ = 0x2;
		n = write_varint(a,e-a,m_pgpgin);
		if (n <= 0)
			return -181;
		a += n;
	}
	// has pgpgout?
	if (0 != (p_validbits & ((uint16_t)1U << 7))) {
		// 'pgpgout': id=39, encoding=0, tag=0x138
		if (2 > (e-a))
			return -182;
		*a++ = 0xb8;
		*a++ = 0x2;
		n = write_varint(a,e-a,m_pgpgout);
		if (n <= 0)
			return -183;
		a += n;
	}
	// has pgfree?
	if (0 != (p_validbits & ((uint16_t)1U << 8))) {
		// 'pgfree': id=46, encoding=0, tag=0x170
		if (2 > (e-a))
			return -184;
		*a++ = 0xf0;
		*a++ = 0x2;
		n = write_varint(a,e-a,m_pgfree);
		if (n <= 0)
			return -185;
		a += n;
	}
	// has pgfault?
	if (0 != (p_validbits & ((uint16_t)1U << 9))) {
		// 'pgfault': id=49, encoding=0, tag=0x188
		if (2 > (e-a))
			return -186;
		*a++ = 0x88;
		*a++ = 0x3;
		n = write_varint(a,e-a,m_pgfault);
		if (n <= 0)
			return -187;
		a += n;
	}
	// has pgmajfault?
	if (0 != (p_validbits & ((uint16_t)1U << 10))) {
		// 'pgmajfault': id=50, encoding=0, tag=0x190
		if (2 > (e-a))
			return -188;
		*a++ = 0x90;
		*a++ = 0x3;
		n = write_varint(a,e-a,m_pgmajfault);
		if (n <= 0)
			return -189;
		a += n;
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope_LinuxVmstat::calcSize() const
{
	size_t r = 0;	// required size, default is fixed length
	// nr_free_pages
	if (0 != (p_validbits & ((uint16_t)1U << 0))) {
		r += wiresize((varint_t)m_nr_free_pages) + 1 /* tag(id) 0x8 */;
	}
	// nr_mlock
	if (0 != (p_validbits & ((uint16_t)1U << 1))) {
		r += wiresize((varint_t)m_nr_mlock) + 1 /* tag(id) 0x40 */;
	}
	// nr_anon_pages
	if (0 != (p_validbits & ((uint16_t)1U << 2))) {
		r += wiresize((varint_t)m_nr_anon_pages) + 1 /* tag(id) 0x48 */;
	}
	// nr_file_pages
	if (0 != (p_validbits & ((uint16_t)1U << 3))) {
		r += wiresize((varint_t)m_nr_file_pages) + 1 /* tag(id) 0x58 */;
	}
	// nr_kernel_stack
	if (0 != (p_validbits & ((uint16_t)1U << 4))) {
		r += wiresize((varint_t)m_nr_kernel_stack) + 2 /* tag(id) 0x88 */;
	}
	// nr_shmem
	if (0 != (p_validbits & ((uint16_t)1U << 5))) {
		r += wiresize((varint_t)m_nr_shmem) + 2 /* tag(id) 0xc8 */;
	}
	// pgpgin
	if (0 != (p_validbits & ((uint16_t)1U << 6))) {
		r += wiresize((varint_t)m_pgpgin) + 2 /* tag(id) 0x130 */;
	}
	// pgpgout
	if (0 != (p_validbits & ((uint16_t)1U << 7))) {
		r += wiresize((varint_t)m_pgpgout) + 2 /* tag(id) 0x138 */;
	}
	// pgfree
	if (0 != (p_validbits & ((uint16_t)1U << 8))) {
		r += wiresize((varint_t)m_pgfree) + 2 /* tag(id) 0x170 */;
	}
	// pgfault
	if (0 != (p_validbits & ((uint16_t)1U << 9))) {
		r += wiresize((varint_t)m_pgfault) + 2 /* tag(id) 0x188 */;
	}
	// pgmajfault
	if (0 != (p_validbits & ((uint16_t)1U << 10))) {
		r += wiresize((varint_t)m_pgmajfault) + 2 /* tag(id) 0x190 */;
	}
	return r;
}

HostScope_LinuxCPU::HostScope_LinuxCPU()
: m_id(0)
, m_user(0)
, m_nice(0)
, m_system(0)
, m_idle(0)
, m_iowait(0)
, m_irq(0)
, m_vhost(0)
, m_currtemp(0)
, m_crittemp(0)
, m_currmhz(0)
, p_validbits(0)
{
}

void HostScope_LinuxCPU::clear()
{
	m_id = 0;
	m_user = 0;
	m_nice = 0;
	m_system = 0;
	m_idle = 0;
	m_iowait = 0;
	m_irq = 0;
	m_vhost = 0;
	m_currtemp = 0;
	m_crittemp = 0;
	m_currmhz = 0;
	p_validbits = 0;
}

ssize_t HostScope_LinuxCPU::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -190;
		switch (fid) {
		case 0x8:	// id id 1, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -191;
				a += n;
				m_id = v;
			}
			break;
		case 0x10:	// user id 2, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -192;
				a += n;
				m_user = v;
			}
			break;
		case 0x18:	// nice id 3, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -193;
				a += n;
				m_nice = v;
			}
			break;
		case 0x20:	// system id 4, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -194;
				a += n;
				m_system = v;
			}
			break;
		case 0x28:	// idle id 5, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -195;
				a += n;
				m_idle = v;
			}
			break;
		case 0x30:	// iowait id 6, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -196;
				a += n;
				m_iowait = v;
			}
			break;
		case 0x38:	// irq id 7, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -197;
				a += n;
				set_irq(v);
			}
			break;
		case 0x40:	// vhost id 8, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -198;
				a += n;
				set_vhost(v);
			}
			break;
		case 0x48:	// currtemp id 9, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -199;
				a += n;
				set_currtemp(v);
			}
			break;
		case 0x50:	// crittemp id 10, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -200;
				a += n;
				set_crittemp(v);
			}
			break;
		case 0x58:	// currmhz id 11, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -201;
				a += n;
				set_currmhz(v);
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -202;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -203;
	return a-(const uint8_t *)b;
}

size_t HostScope_LinuxCPU::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// 'id': id=1, encoding=0, tag=0x8
	if (a >= e)
		return -204;
	*a++ = 0x8;
	n = write_varint(a,e-a,m_id);
	if (n <= 0)
		return -205;
	a += n;
	// 'user': id=2, encoding=0, tag=0x10
	if (a >= e)
		return -206;
	*a++ = 0x10;
	n = write_varint(a,e-a,m_user);
	if (n <= 0)
		return -207;
	a += n;
	// 'nice': id=3, encoding=0, tag=0x18
	if (a >= e)
		return -208;
	*a++ = 0x18;
	n = write_varint(a,e-a,m_nice);
	if (n <= 0)
		return -209;
	a += n;
	// 'system': id=4, encoding=0, tag=0x20
	if (a >= e)
		return -210;
	*a++ = 0x20;
	n = write_varint(a,e-a,m_system);
	if (n <= 0)
		return -211;
	a += n;
	// 'idle': id=5, encoding=0, tag=0x28
	if (a >= e)
		return -212;
	*a++ = 0x28;
	n = write_varint(a,e-a,m_idle);
	if (n <= 0)
		return -213;
	a += n;
	// 'iowait': id=6, encoding=0, tag=0x30
	if (a >= e)
		return -214;
	*a++ = 0x30;
	n = write_varint(a,e-a,m_iowait);
	if (n <= 0)
		return -215;
	a += n;
	// has irq?
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		// 'irq': id=7, encoding=0, tag=0x38
		if (a >= e)
			return -216;
		*a++ = 0x38;
		n = write_varint(a,e-a,m_irq);
		if (n <= 0)
			return -217;
		a += n;
	}
	// has vhost?
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		// 'vhost': id=8, encoding=0, tag=0x40
		if (a >= e)
			return -218;
		*a++ = 0x40;
		n = write_varint(a,e-a,m_vhost);
		if (n <= 0)
			return -219;
		a += n;
	}
	// has currtemp?
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		// 'currtemp': id=9, encoding=0, tag=0x48
		if (a >= e)
			return -220;
		*a++ = 0x48;
		n = write_varint(a,e-a,m_currtemp);
		if (n <= 0)
			return -221;
		a += n;
	}
	// has crittemp?
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		// 'crittemp': id=10, encoding=0, tag=0x50
		if (a >= e)
			return -222;
		*a++ = 0x50;
		n = write_varint(a,e-a,m_crittemp);
		if (n <= 0)
			return -223;
		a += n;
	}
	// has currmhz?
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		// 'currmhz': id=11, encoding=0, tag=0x58
		if (a >= e)
			return -224;
		*a++ = 0x58;
		n = write_varint(a,e-a,m_currmhz);
		if (n <= 0)
			return -225;
		a += n;
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope_LinuxCPU::calcSize() const
{
	// id: tagsize 1
	// user: tagsize 1
	// nice: tagsize 1
	// system: tagsize 1
	// idle: tagsize 1
	// iowait: tagsize 1
	size_t r = 6;	// required size, default is fixed length
	// id
	r += wiresize((varint_t)m_id);
	// user
	r += wiresize((varint_t)m_user);
	// nice
	r += wiresize((varint_t)m_nice);
	// system
	r += wiresize((varint_t)m_system);
	// idle
	r += wiresize((varint_t)m_idle);
	// iowait
	r += wiresize((varint_t)m_iowait);
	// irq
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		r += wiresize((varint_t)m_irq) + 1 /* tag(id) 0x38 */;
	}
	// vhost
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		r += wiresize((varint_t)m_vhost) + 1 /* tag(id) 0x40 */;
	}
	// currtemp
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		r += wiresize((varint_t)m_currtemp) + 1 /* tag(id) 0x48 */;
	}
	// crittemp
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		r += wiresize((varint_t)m_crittemp) + 1 /* tag(id) 0x50 */;
	}
	// currmhz
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		r += wiresize((varint_t)m_currmhz) + 1 /* tag(id) 0x58 */;
	}
	return r;
}

HostScope_Process::HostScope_Process()
: m_command()
, m_pid(0)
, m_uid(0)
, m_prio(0)
, m_nthreads(0)
, m_time(0)
, m_putime(0)
, m_pstime(0)
, m_virmem(0)
, m_rssmem(0)
, m_sharedmem(0)
, m_minflts(0)
, m_majflts(0)
, m_rchars(0)
, m_wchars(0)
, p_validbits(0)
{
}

void HostScope_Process::clear()
{
	m_command.clear();
	m_pid = 0;
	m_uid = 0;
	m_prio = 0;
	m_nthreads = 0;
	m_time = 0;
	m_putime = 0;
	m_pstime = 0;
	m_virmem = 0;
	m_rssmem = 0;
	m_sharedmem = 0;
	m_minflts = 0;
	m_majflts = 0;
	m_rchars = 0;
	m_wchars = 0;
	p_validbits = 0;
}

ssize_t HostScope_Process::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -226;
		switch (fid) {
		case 0xa:	// command id 1, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -227;
				m_command.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x10:	// pid id 2, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -228;
				a += n;
				m_pid = v;
			}
			break;
		case 0x18:	// uid id 3, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -229;
				a += n;
				m_uid = v;
			}
			break;
		case 0x20:	// prio id 4, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -230;
				a += n;
				set_prio(v);
			}
			break;
		case 0x28:	// nthreads id 5, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -231;
				a += n;
				set_nthreads(v);
			}
			break;
		case 0x40:	// time id 8, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -232;
				a += n;
				set_time(v);
			}
			break;
		case 0x48:	// putime id 9, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -233;
				a += n;
				set_putime(v);
			}
			break;
		case 0x50:	// pstime id 10, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -234;
				a += n;
				set_pstime(v);
			}
			break;
		case 0x80:	// virmem id 16, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -235;
				a += n;
				set_virmem(v);
			}
			break;
		case 0x88:	// rssmem id 17, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -236;
				a += n;
				set_rssmem(v);
			}
			break;
		case 0x90:	// sharedmem id 18, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -237;
				a += n;
				set_sharedmem(v);
			}
			break;
		case 0xe0:	// minflts id 28, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -238;
				a += n;
				set_minflts(v);
			}
			break;
		case 0xe8:	// majflts id 29, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -239;
				a += n;
				set_majflts(v);
			}
			break;
		case 0xf0:	// rchars id 30, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -240;
				a += n;
				set_rchars(v);
			}
			break;
		case 0xf8:	// wchars id 31, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -241;
				a += n;
				set_wchars(v);
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -242;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -243;
	return a-(const uint8_t *)b;
}

size_t HostScope_Process::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// 'command': id=1, encoding=2, tag=0xa
	if (a >= e)
		return -244;
	*a++ = 0xa;
	ssize_t command_s = m_command.size();
	n = write_varint(a,e-a,command_s);
	a += n;
	if ((n <= 0) || ((e-a) < command_s))
		return -245;
	memcpy(a,m_command.data(),command_s);
	a += command_s;
	// 'pid': id=2, encoding=0, tag=0x10
	if (a >= e)
		return -246;
	*a++ = 0x10;
	n = write_varint(a,e-a,m_pid);
	if (n <= 0)
		return -247;
	a += n;
	// 'uid': id=3, encoding=0, tag=0x18
	if (a >= e)
		return -248;
	*a++ = 0x18;
	n = write_varint(a,e-a,m_uid);
	if (n <= 0)
		return -249;
	a += n;
	// has prio?
	if (0 != (p_validbits & ((uint16_t)1U << 0))) {
		// 'prio': id=4, encoding=0, tag=0x20
		if (a >= e)
			return -250;
		*a++ = 0x20;
		n = write_varint(a,e-a,m_prio);
		if (n <= 0)
			return -251;
		a += n;
	}
	// has nthreads?
	if (0 != (p_validbits & ((uint16_t)1U << 1))) {
		// 'nthreads': id=5, encoding=0, tag=0x28
		if (a >= e)
			return -252;
		*a++ = 0x28;
		n = write_varint(a,e-a,m_nthreads);
		if (n <= 0)
			return -253;
		a += n;
	}
	// has time?
	if (0 != (p_validbits & ((uint16_t)1U << 2))) {
		// 'time': id=8, encoding=0, tag=0x40
		if (a >= e)
			return -254;
		*a++ = 0x40;
		n = write_varint(a,e-a,m_time);
		if (n <= 0)
			return -255;
		a += n;
	}
	// has putime?
	if (0 != (p_validbits & ((uint16_t)1U << 3))) {
		// 'putime': id=9, encoding=0, tag=0x48
		if (a >= e)
			return -256;
		*a++ = 0x48;
		n = write_varint(a,e-a,m_putime);
		if (n <= 0)
			return -257;
		a += n;
	}
	// has pstime?
	if (0 != (p_validbits & ((uint16_t)1U << 4))) {
		// 'pstime': id=10, encoding=0, tag=0x50
		if (a >= e)
			return -258;
		*a++ = 0x50;
		n = write_varint(a,e-a,m_pstime);
		if (n <= 0)
			return -259;
		a += n;
	}
	// has virmem?
	if (0 != (p_validbits & ((uint16_t)1U << 5))) {
		// 'virmem': id=16, encoding=0, tag=0x80
		if (2 > (e-a))
			return -260;
		*a++ = 0x80;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_virmem);
		if (n <= 0)
			return -261;
		a += n;
	}
	// has rssmem?
	if (0 != (p_validbits & ((uint16_t)1U << 6))) {
		// 'rssmem': id=17, encoding=0, tag=0x88
		if (2 > (e-a))
			return -262;
		*a++ = 0x88;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_rssmem);
		if (n <= 0)
			return -263;
		a += n;
	}
	// has sharedmem?
	if (0 != (p_validbits & ((uint16_t)1U << 7))) {
		// 'sharedmem': id=18, encoding=0, tag=0x90
		if (2 > (e-a))
			return -264;
		*a++ = 0x90;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_sharedmem);
		if (n <= 0)
			return -265;
		a += n;
	}
	// has minflts?
	if (0 != (p_validbits & ((uint16_t)1U << 8))) {
		// 'minflts': id=28, encoding=0, tag=0xe0
		if (2 > (e-a))
			return -266;
		*a++ = 0xe0;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_minflts);
		if (n <= 0)
			return -267;
		a += n;
	}
	// has majflts?
	if (0 != (p_validbits & ((uint16_t)1U << 9))) {
		// 'majflts': id=29, encoding=0, tag=0xe8
		if (2 > (e-a))
			return -268;
		*a++ = 0xe8;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_majflts);
		if (n <= 0)
			return -269;
		a += n;
	}
	// has rchars?
	if (0 != (p_validbits & ((uint16_t)1U << 10))) {
		// 'rchars': id=30, encoding=0, tag=0xf0
		if (2 > (e-a))
			return -270;
		*a++ = 0xf0;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_rchars);
		if (n <= 0)
			return -271;
		a += n;
	}
	// has wchars?
	if (0 != (p_validbits & ((uint16_t)1U << 11))) {
		// 'wchars': id=31, encoding=0, tag=0xf8
		if (2 > (e-a))
			return -272;
		*a++ = 0xf8;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_wchars);
		if (n <= 0)
			return -273;
		a += n;
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope_Process::calcSize() const
{
	// command: tagsize 1
	// pid: tagsize 1
	// uid: tagsize 1
	size_t r = 3;	// required size, default is fixed length
	// command
	size_t command_s = m_command.size();
	r += command_s + wiresize(command_s);
	// pid
	r += wiresize((varint_t)m_pid);
	// uid
	r += wiresize((varint_t)m_uid);
	// prio
	if (0 != (p_validbits & ((uint16_t)1U << 0))) {
		r += wiresize((varint_t)m_prio) + 1 /* tag(id) 0x20 */;
	}
	// nthreads
	if (0 != (p_validbits & ((uint16_t)1U << 1))) {
		r += wiresize((varint_t)m_nthreads) + 1 /* tag(id) 0x28 */;
	}
	// time
	if (0 != (p_validbits & ((uint16_t)1U << 2))) {
		r += wiresize((varint_t)m_time) + 1 /* tag(id) 0x40 */;
	}
	// putime
	if (0 != (p_validbits & ((uint16_t)1U << 3))) {
		r += wiresize((varint_t)m_putime) + 1 /* tag(id) 0x48 */;
	}
	// pstime
	if (0 != (p_validbits & ((uint16_t)1U << 4))) {
		r += wiresize((varint_t)m_pstime) + 1 /* tag(id) 0x50 */;
	}
	// virmem
	if (0 != (p_validbits & ((uint16_t)1U << 5))) {
		r += wiresize((varint_t)m_virmem) + 2 /* tag(id) 0x80 */;
	}
	// rssmem
	if (0 != (p_validbits & ((uint16_t)1U << 6))) {
		r += wiresize((varint_t)m_rssmem) + 2 /* tag(id) 0x88 */;
	}
	// sharedmem
	if (0 != (p_validbits & ((uint16_t)1U << 7))) {
		r += wiresize((varint_t)m_sharedmem) + 2 /* tag(id) 0x90 */;
	}
	// minflts
	if (0 != (p_validbits & ((uint16_t)1U << 8))) {
		r += wiresize((varint_t)m_minflts) + 2 /* tag(id) 0xe0 */;
	}
	// majflts
	if (0 != (p_validbits & ((uint16_t)1U << 9))) {
		r += wiresize((varint_t)m_majflts) + 2 /* tag(id) 0xe8 */;
	}
	// rchars
	if (0 != (p_validbits & ((uint16_t)1U << 10))) {
		r += wiresize((varint_t)m_rchars) + 2 /* tag(id) 0xf0 */;
	}
	// wchars
	if (0 != (p_validbits & ((uint16_t)1U << 11))) {
		r += wiresize((varint_t)m_wchars) + 2 /* tag(id) 0xf8 */;
	}
	return r;
}

HostScope_User::HostScope_User()
: m_uid(0)
, m_name()
, m_nproc(0)
, m_nthreads(0)
, m_rssmem(0)
, m_sharedmem(0)
, m_minflts(0)
, m_majflts(0)
, m_putime(0)
, m_pstime(0)
, m_rchars(0)
, m_wchars(0)
, p_validbits(0)
{
}

void HostScope_User::clear()
{
	m_uid = 0;
	m_name.clear();
	m_nproc = 0;
	m_nthreads = 0;
	m_rssmem = 0;
	m_sharedmem = 0;
	m_minflts = 0;
	m_majflts = 0;
	m_putime = 0;
	m_pstime = 0;
	m_rchars = 0;
	m_wchars = 0;
	p_validbits = 0;
}

ssize_t HostScope_User::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -274;
		switch (fid) {
		case 0x8:	// uid id 1, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -275;
				a += n;
				m_uid = v;
			}
			break;
		case 0x12:	// name id 2, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -276;
				m_name.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x18:	// nproc id 3, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -277;
				a += n;
				m_nproc = v;
			}
			break;
		case 0x20:	// nthreads id 4, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -278;
				a += n;
				set_nthreads(v);
			}
			break;
		case 0x40:	// rssmem id 8, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -279;
				a += n;
				set_rssmem(v);
			}
			break;
		case 0x48:	// sharedmem id 9, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -280;
				a += n;
				set_sharedmem(v);
			}
			break;
		case 0x60:	// minflts id 12, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -281;
				a += n;
				set_minflts(v);
			}
			break;
		case 0x68:	// majflts id 13, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -282;
				a += n;
				set_majflts(v);
			}
			break;
		case 0x80:	// putime id 16, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -283;
				a += n;
				set_putime(v);
			}
			break;
		case 0x88:	// pstime id 17, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -284;
				a += n;
				set_pstime(v);
			}
			break;
		case 0xa0:	// rchars id 20, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -285;
				a += n;
				set_rchars(v);
			}
			break;
		case 0xa8:	// wchars id 21, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -286;
				a += n;
				set_wchars(v);
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -287;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -288;
	return a-(const uint8_t *)b;
}

size_t HostScope_User::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// 'uid': id=1, encoding=0, tag=0x8
	if (a >= e)
		return -289;
	*a++ = 0x8;
	n = write_varint(a,e-a,m_uid);
	if (n <= 0)
		return -290;
	a += n;
	// 'name': id=2, encoding=2, tag=0x12
	if (a >= e)
		return -291;
	*a++ = 0x12;
	ssize_t name_s = m_name.size();
	n = write_varint(a,e-a,name_s);
	a += n;
	if ((n <= 0) || ((e-a) < name_s))
		return -292;
	memcpy(a,m_name.data(),name_s);
	a += name_s;
	// 'nproc': id=3, encoding=0, tag=0x18
	if (a >= e)
		return -293;
	*a++ = 0x18;
	n = write_varint(a,e-a,m_nproc);
	if (n <= 0)
		return -294;
	a += n;
	// has nthreads?
	if (0 != (p_validbits & ((uint16_t)1U << 0))) {
		// 'nthreads': id=4, encoding=0, tag=0x20
		if (a >= e)
			return -295;
		*a++ = 0x20;
		n = write_varint(a,e-a,m_nthreads);
		if (n <= 0)
			return -296;
		a += n;
	}
	// has rssmem?
	if (0 != (p_validbits & ((uint16_t)1U << 1))) {
		// 'rssmem': id=8, encoding=0, tag=0x40
		if (a >= e)
			return -297;
		*a++ = 0x40;
		n = write_varint(a,e-a,m_rssmem);
		if (n <= 0)
			return -298;
		a += n;
	}
	// has sharedmem?
	if (0 != (p_validbits & ((uint16_t)1U << 2))) {
		// 'sharedmem': id=9, encoding=0, tag=0x48
		if (a >= e)
			return -299;
		*a++ = 0x48;
		n = write_varint(a,e-a,m_sharedmem);
		if (n <= 0)
			return -300;
		a += n;
	}
	// has minflts?
	if (0 != (p_validbits & ((uint16_t)1U << 3))) {
		// 'minflts': id=12, encoding=0, tag=0x60
		if (a >= e)
			return -301;
		*a++ = 0x60;
		n = write_varint(a,e-a,m_minflts);
		if (n <= 0)
			return -302;
		a += n;
	}
	// has majflts?
	if (0 != (p_validbits & ((uint16_t)1U << 4))) {
		// 'majflts': id=13, encoding=0, tag=0x68
		if (a >= e)
			return -303;
		*a++ = 0x68;
		n = write_varint(a,e-a,m_majflts);
		if (n <= 0)
			return -304;
		a += n;
	}
	// has putime?
	if (0 != (p_validbits & ((uint16_t)1U << 5))) {
		// 'putime': id=16, encoding=0, tag=0x80
		if (2 > (e-a))
			return -305;
		*a++ = 0x80;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_putime);
		if (n <= 0)
			return -306;
		a += n;
	}
	// has pstime?
	if (0 != (p_validbits & ((uint16_t)1U << 6))) {
		// 'pstime': id=17, encoding=0, tag=0x88
		if (2 > (e-a))
			return -307;
		*a++ = 0x88;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_pstime);
		if (n <= 0)
			return -308;
		a += n;
	}
	// has rchars?
	if (0 != (p_validbits & ((uint16_t)1U << 7))) {
		// 'rchars': id=20, encoding=0, tag=0xa0
		if (2 > (e-a))
			return -309;
		*a++ = 0xa0;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_rchars);
		if (n <= 0)
			return -310;
		a += n;
	}
	// has wchars?
	if (0 != (p_validbits & ((uint16_t)1U << 8))) {
		// 'wchars': id=21, encoding=0, tag=0xa8
		if (2 > (e-a))
			return -311;
		*a++ = 0xa8;
		*a++ = 0x1;
		n = write_varint(a,e-a,m_wchars);
		if (n <= 0)
			return -312;
		a += n;
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope_User::calcSize() const
{
	// uid: tagsize 1
	// name: tagsize 1
	// nproc: tagsize 1
	size_t r = 3;	// required size, default is fixed length
	// uid
	r += wiresize((varint_t)m_uid);
	// name
	size_t name_s = m_name.size();
	r += name_s + wiresize(name_s);
	// nproc
	r += wiresize((varint_t)m_nproc);
	// nthreads
	if (0 != (p_validbits & ((uint16_t)1U << 0))) {
		r += wiresize((varint_t)m_nthreads) + 1 /* tag(id) 0x20 */;
	}
	// rssmem
	if (0 != (p_validbits & ((uint16_t)1U << 1))) {
		r += wiresize((varint_t)m_rssmem) + 1 /* tag(id) 0x40 */;
	}
	// sharedmem
	if (0 != (p_validbits & ((uint16_t)1U << 2))) {
		r += wiresize((varint_t)m_sharedmem) + 1 /* tag(id) 0x48 */;
	}
	// minflts
	if (0 != (p_validbits & ((uint16_t)1U << 3))) {
		r += wiresize((varint_t)m_minflts) + 1 /* tag(id) 0x60 */;
	}
	// majflts
	if (0 != (p_validbits & ((uint16_t)1U << 4))) {
		r += wiresize((varint_t)m_majflts) + 1 /* tag(id) 0x68 */;
	}
	// putime
	if (0 != (p_validbits & ((uint16_t)1U << 5))) {
		r += wiresize((varint_t)m_putime) + 2 /* tag(id) 0x80 */;
	}
	// pstime
	if (0 != (p_validbits & ((uint16_t)1U << 6))) {
		r += wiresize((varint_t)m_pstime) + 2 /* tag(id) 0x88 */;
	}
	// rchars
	if (0 != (p_validbits & ((uint16_t)1U << 7))) {
		r += wiresize((varint_t)m_rchars) + 2 /* tag(id) 0xa0 */;
	}
	// wchars
	if (0 != (p_validbits & ((uint16_t)1U << 8))) {
		r += wiresize((varint_t)m_wchars) + 2 /* tag(id) 0xa8 */;
	}
	return r;
}

HostScope_Disk::HostScope_Disk()
: m_devname()
, m_ktotal(0)
, m_nops(0)
, m_nread(0)
, m_nwrite(0)
, m_kread(0)
, m_kwrite(0)
, m_perc_busy(0)
, m_opsqueued(0)
, p_validbits(0)
{
}

void HostScope_Disk::clear()
{
	m_devname.clear();
	m_ktotal = 0;
	m_nops = 0;
	m_nread = 0;
	m_nwrite = 0;
	m_kread = 0;
	m_kwrite = 0;
	m_perc_busy = 0;
	m_opsqueued = 0;
	p_validbits = 0;
}

ssize_t HostScope_Disk::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -313;
		switch (fid) {
		case 0xa:	// devname id 1, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -314;
				m_devname.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x10:	// ktotal id 2, type uint64_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -315;
				a += n;
				set_ktotal(v);
			}
			break;
		case 0x20:	// nops id 4, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -316;
				a += n;
				set_nops(v);
			}
			break;
		case 0x28:	// nread id 5, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -317;
				a += n;
				set_nread(v);
			}
			break;
		case 0x30:	// nwrite id 6, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -318;
				a += n;
				set_nwrite(v);
			}
			break;
		case 0x40:	// kread id 8, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -319;
				a += n;
				set_kread(v);
			}
			break;
		case 0x48:	// kwrite id 9, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -320;
				a += n;
				set_kwrite(v);
			}
			break;
		case 0x50:	// perc_busy id 10, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -321;
				a += n;
				set_perc_busy(v);
			}
			break;
		case 0x60:	// opsqueued id 12, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -322;
				a += n;
				set_opsqueued(v);
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -323;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -324;
	return a-(const uint8_t *)b;
}

size_t HostScope_Disk::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// 'devname': id=1, encoding=2, tag=0xa
	if (a >= e)
		return -325;
	*a++ = 0xa;
	ssize_t devname_s = m_devname.size();
	n = write_varint(a,e-a,devname_s);
	a += n;
	if ((n <= 0) || ((e-a) < devname_s))
		return -326;
	memcpy(a,m_devname.data(),devname_s);
	a += devname_s;
	// has ktotal?
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		// 'ktotal': id=2, encoding=0, tag=0x10
		if (a >= e)
			return -327;
		*a++ = 0x10;
		n = write_varint(a,e-a,m_ktotal);
		if (n <= 0)
			return -328;
		a += n;
	}
	// has nops?
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		// 'nops': id=4, encoding=0, tag=0x20
		if (a >= e)
			return -329;
		*a++ = 0x20;
		n = write_varint(a,e-a,m_nops);
		if (n <= 0)
			return -330;
		a += n;
	}
	// has nread?
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		// 'nread': id=5, encoding=0, tag=0x28
		if (a >= e)
			return -331;
		*a++ = 0x28;
		n = write_varint(a,e-a,m_nread);
		if (n <= 0)
			return -332;
		a += n;
	}
	// has nwrite?
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		// 'nwrite': id=6, encoding=0, tag=0x30
		if (a >= e)
			return -333;
		*a++ = 0x30;
		n = write_varint(a,e-a,m_nwrite);
		if (n <= 0)
			return -334;
		a += n;
	}
	// has kread?
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		// 'kread': id=8, encoding=0, tag=0x40
		if (a >= e)
			return -335;
		*a++ = 0x40;
		n = write_varint(a,e-a,m_kread);
		if (n <= 0)
			return -336;
		a += n;
	}
	// has kwrite?
	if (0 != (p_validbits & ((uint8_t)1U << 5))) {
		// 'kwrite': id=9, encoding=0, tag=0x48
		if (a >= e)
			return -337;
		*a++ = 0x48;
		n = write_varint(a,e-a,m_kwrite);
		if (n <= 0)
			return -338;
		a += n;
	}
	// has perc_busy?
	if (0 != (p_validbits & ((uint8_t)1U << 6))) {
		// 'perc_busy': id=10, encoding=0, tag=0x50
		if (a >= e)
			return -339;
		*a++ = 0x50;
		n = write_varint(a,e-a,m_perc_busy);
		if (n <= 0)
			return -340;
		a += n;
	}
	// has opsqueued?
	if (0 != (p_validbits & ((uint8_t)1U << 7))) {
		// 'opsqueued': id=12, encoding=0, tag=0x60
		if (a >= e)
			return -341;
		*a++ = 0x60;
		n = write_varint(a,e-a,m_opsqueued);
		if (n <= 0)
			return -342;
		a += n;
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope_Disk::calcSize() const
{
	// devname: tagsize 1
	size_t r = 1;	// required size, default is fixed length
	// devname
	size_t devname_s = m_devname.size();
	r += devname_s + wiresize(devname_s);
	// ktotal
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		r += wiresize((varint_t)m_ktotal) + 1 /* tag(id) 0x10 */;
	}
	// nops
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		r += wiresize((varint_t)m_nops) + 1 /* tag(id) 0x20 */;
	}
	// nread
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		r += wiresize((varint_t)m_nread) + 1 /* tag(id) 0x28 */;
	}
	// nwrite
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		r += wiresize((varint_t)m_nwrite) + 1 /* tag(id) 0x30 */;
	}
	// kread
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		r += wiresize((varint_t)m_kread) + 1 /* tag(id) 0x40 */;
	}
	// kwrite
	if (0 != (p_validbits & ((uint8_t)1U << 5))) {
		r += wiresize((varint_t)m_kwrite) + 1 /* tag(id) 0x48 */;
	}
	// perc_busy
	if (0 != (p_validbits & ((uint8_t)1U << 6))) {
		r += wiresize((varint_t)m_perc_busy) + 1 /* tag(id) 0x50 */;
	}
	// opsqueued
	if (0 != (p_validbits & ((uint8_t)1U << 7))) {
		r += wiresize((varint_t)m_opsqueued) + 1 /* tag(id) 0x60 */;
	}
	return r;
}

HostScope_NetDevice::HostScope_NetDevice()
: m_devname()
, m_nreceived(0)
, m_kreceived(0)
, m_ereceived(0)
, m_dreceived(0)
, m_ntransmit(0)
, m_ktransmit(0)
, m_etransmit(0)
, m_dtransmit(0)
, p_validbits(0)
{
}

void HostScope_NetDevice::clear()
{
	m_devname.clear();
	m_nreceived = 0;
	m_kreceived = 0;
	m_ereceived = 0;
	m_dreceived = 0;
	m_ntransmit = 0;
	m_ktransmit = 0;
	m_etransmit = 0;
	m_dtransmit = 0;
	p_validbits = 0;
}

ssize_t HostScope_NetDevice::fromMemory(const void *b, ssize_t s)
{
	const uint8_t *a = (const uint8_t *)b;
	const uint8_t *e = a + s;
	while (a < e) {
		varint_t fid;
		int fn = read_varint(a,e-a,&fid);
		a += fn;
		if (fn <= 0)
			return -343;
		switch (fid) {
		case 0xa:	// devname id 1, type std::string, coding byte[]
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				a += n;
				if ((n <= 0) || ((a+v) > e))
					return -344;
				m_devname.assign((const char*)a,v);
				a += v;
			}
			break;
		case 0x10:	// nreceived id 2, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -345;
				a += n;
				set_nreceived(v);
			}
			break;
		case 0x18:	// kreceived id 3, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -346;
				a += n;
				set_kreceived(v);
			}
			break;
		case 0x20:	// ereceived id 4, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -347;
				a += n;
				set_ereceived(v);
			}
			break;
		case 0x28:	// dreceived id 5, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -348;
				a += n;
				set_dreceived(v);
			}
			break;
		case 0x30:	// ntransmit id 6, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -349;
				a += n;
				set_ntransmit(v);
			}
			break;
		case 0x38:	// ktransmit id 7, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -350;
				a += n;
				set_ktransmit(v);
			}
			break;
		case 0x40:	// etransmit id 8, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -351;
				a += n;
				set_etransmit(v);
			}
			break;
		case 0x48:	// dtransmit id 9, type uint32_t, coding varint
			{
				varint_t v;
				int n = read_varint(a,e-a,&v);
				if (n <= 0)
					return -352;
				a += n;
				set_dtransmit(v);
			}
			break;
		default:
			{
				ssize_t s = skip_content(a,e-a,fid&7);
				if (s <= 0)
					return -353;
				a += s;
				break;
			}
		}
	}
	assert((a-(const uint8_t *)b) == s);
	if (a > e)
		return -354;
	return a-(const uint8_t *)b;
}

size_t HostScope_NetDevice::toMemory(uint8_t *b, ssize_t s) const
{
	assert(s >= 0);
	uint8_t *a = b, *e = b + s;
	signed n;
	// 'devname': id=1, encoding=2, tag=0xa
	if (a >= e)
		return -355;
	*a++ = 0xa;
	ssize_t devname_s = m_devname.size();
	n = write_varint(a,e-a,devname_s);
	a += n;
	if ((n <= 0) || ((e-a) < devname_s))
		return -356;
	memcpy(a,m_devname.data(),devname_s);
	a += devname_s;
	// has nreceived?
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		// 'nreceived': id=2, encoding=0, tag=0x10
		if (a >= e)
			return -357;
		*a++ = 0x10;
		n = write_varint(a,e-a,m_nreceived);
		if (n <= 0)
			return -358;
		a += n;
	}
	// has kreceived?
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		// 'kreceived': id=3, encoding=0, tag=0x18
		if (a >= e)
			return -359;
		*a++ = 0x18;
		n = write_varint(a,e-a,m_kreceived);
		if (n <= 0)
			return -360;
		a += n;
	}
	// has ereceived?
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		// 'ereceived': id=4, encoding=0, tag=0x20
		if (a >= e)
			return -361;
		*a++ = 0x20;
		n = write_varint(a,e-a,m_ereceived);
		if (n <= 0)
			return -362;
		a += n;
	}
	// has dreceived?
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		// 'dreceived': id=5, encoding=0, tag=0x28
		if (a >= e)
			return -363;
		*a++ = 0x28;
		n = write_varint(a,e-a,m_dreceived);
		if (n <= 0)
			return -364;
		a += n;
	}
	// has ntransmit?
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		// 'ntransmit': id=6, encoding=0, tag=0x30
		if (a >= e)
			return -365;
		*a++ = 0x30;
		n = write_varint(a,e-a,m_ntransmit);
		if (n <= 0)
			return -366;
		a += n;
	}
	// has ktransmit?
	if (0 != (p_validbits & ((uint8_t)1U << 5))) {
		// 'ktransmit': id=7, encoding=0, tag=0x38
		if (a >= e)
			return -367;
		*a++ = 0x38;
		n = write_varint(a,e-a,m_ktransmit);
		if (n <= 0)
			return -368;
		a += n;
	}
	// has etransmit?
	if (0 != (p_validbits & ((uint8_t)1U << 6))) {
		// 'etransmit': id=8, encoding=0, tag=0x40
		if (a >= e)
			return -369;
		*a++ = 0x40;
		n = write_varint(a,e-a,m_etransmit);
		if (n <= 0)
			return -370;
		a += n;
	}
	// has dtransmit?
	if (0 != (p_validbits & ((uint8_t)1U << 7))) {
		// 'dtransmit': id=9, encoding=0, tag=0x48
		if (a >= e)
			return -371;
		*a++ = 0x48;
		n = write_varint(a,e-a,m_dtransmit);
		if (n <= 0)
			return -372;
		a += n;
	}
	assert(a <= e);
	return a-b;
}

size_t HostScope_NetDevice::calcSize() const
{
	// devname: tagsize 1
	size_t r = 1;	// required size, default is fixed length
	// devname
	size_t devname_s = m_devname.size();
	r += devname_s + wiresize(devname_s);
	// nreceived
	if (0 != (p_validbits & ((uint8_t)1U << 0))) {
		r += wiresize((varint_t)m_nreceived) + 1 /* tag(id) 0x10 */;
	}
	// kreceived
	if (0 != (p_validbits & ((uint8_t)1U << 1))) {
		r += wiresize((varint_t)m_kreceived) + 1 /* tag(id) 0x18 */;
	}
	// ereceived
	if (0 != (p_validbits & ((uint8_t)1U << 2))) {
		r += wiresize((varint_t)m_ereceived) + 1 /* tag(id) 0x20 */;
	}
	// dreceived
	if (0 != (p_validbits & ((uint8_t)1U << 3))) {
		r += wiresize((varint_t)m_dreceived) + 1 /* tag(id) 0x28 */;
	}
	// ntransmit
	if (0 != (p_validbits & ((uint8_t)1U << 4))) {
		r += wiresize((varint_t)m_ntransmit) + 1 /* tag(id) 0x30 */;
	}
	// ktransmit
	if (0 != (p_validbits & ((uint8_t)1U << 5))) {
		r += wiresize((varint_t)m_ktransmit) + 1 /* tag(id) 0x38 */;
	}
	// etransmit
	if (0 != (p_validbits & ((uint8_t)1U << 6))) {
		r += wiresize((varint_t)m_etransmit) + 1 /* tag(id) 0x40 */;
	}
	// dtransmit
	if (0 != (p_validbits & ((uint8_t)1U << 7))) {
		r += wiresize((varint_t)m_dtransmit) + 1 /* tag(id) 0x48 */;
	}
	return r;
}

